<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"] ?: array()) + array("_c95cbc31" . "6178c9769" . "7a403f4d9" . "124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0c" . "yBGUk9NIHNpbXBsZV9hY2wgV0hFUk" . "Ugb2JqZWN0X2NvZGUgZXE6c3RyOmN" . "vZGU="), "_a8b22fedb2" . "7a11e07f5bb" . "9a7c73608ea" => base64_decode("c3RyKDE" . "wMCk6b2" . "JqZWN0X" . "2NvZGU="), "_ef2948c87ef" . "38aab9226e41" . "189b29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29" . "kZSBlcTpzdHI6Y29kZQ=="), "_3cda3f34ada928e4aa39d46" . "29c5504aa" => base64_decode("aW50OnJpZ2h0" . "cw=="), "_dbbe14f567693a" . "631f8a43b65af91" . "7ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFiYXNlOiBvYmplY3QgY29kZSBub3Qgc3Bl" . "Y2lmaWVk"), "_80fc2a45acd0150df87d1fb728" . "940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6" . "c3RyOmNvZGUgQU5EIHVzZXJfaWQ9aW50OnVpZA=="), "_84718d828d2acc3" . "c366f96b07e841f6" . "a" => base64_decode("YWNs" . "LnNp" . "bXBs" . "ZQ=="), "_a7ed4d7408bb99b87a09d89d" . "4212d5de" => base64_decode("c2ltcGx" . "lX2FjbA" . "=="), "_b06968b9268deaf3b3" . "80bd0fe922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSR" . "SBvYmplY3RfY29kZSBlcTpzdHI6Y29kZSBBTk" . "QgdXNlcl9pZD1pbnQ6dWlk"), "_27de5a45db71b" . "f24058769b61b3" . "975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzcGVjaWZ" . "pZWQ="), "_938704c4c0169c3804d4b" . "d6aa9941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzcGVjaW" . "ZpZWQ="), "_0877a0b48cf424a0de57a453" . "ce95e30c" => base64_decode("aW50On" . "VzZXJf" . "aWQ="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_84718d828d2acc3c36" . "6f96b07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_80fc2a45acd0150d" . "f87d1fb728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_a7ed4d7408bb99b" . "87a09d89d4212d5d" . "e"], [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_a8b22fedb27a11e07f5bb9a7c73608e" . "a"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_0877a0b48c" . "f424a0de57a" . "453ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_3cda3f34ada928e4aa39d46" . "29c5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_b06968b9268" . "deaf3b380bd0" . "fe922b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_938704c4c0169c3804d" . "4bd6aa9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_c95cbc316178c" . "97697a403f4d91" . "24106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_27de5a45db71bf24058769b61b397" . "5a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_dbbe14f567693a631f8a43b" . "65af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_ef2948c87ef38aab9226e41" . "189b29ca7"], $acl->GetObjectCode());
    }
}